DAT programName         byte "Eight7SegmentsDemo140905d", 0
CON
{{
  ******* Public Notes *******

  Author: Duane Degn

  An attempt to drive eight 7-segment displays with
  two '595 shift registers.
  For more information see the following thread in the
  Parallax forums.
  http://forums.parallax.com/showthread.php/157074
 
}}

{
  ******* Private Notes *******

  23a Start adapting program to display numbers
  on a 7-segment display
  26a Update program based on schematic posted to the forum.
  27b Add delay and "COMMON_ANODE" constant.
  27c Correct some of the comments and upload to forum.
  27d Change to correspond to Arduino code from Robot Shop.
  Change name from "Shift7Segment140905a" to "Eight7Segments140905a"
  140905a Swapped the order of the digits and removed the delay between
  digits. Works as expected.
  Change name from "Eight7Segments140905a" to "Eight7SegmentsDemo140905a".
  05b Start working on making a demo program to use the child object
  "Eight7Segments140905c" (and later).
  05c Have delay between changing numbers continously change.
  05d Simplify demo.
}
{{  

}}
CON '' Pin Assignments
  
  SHIFT_REGISTER_DATA = 0
  SHIFT_REGISTER_CLOCK = 1
  SHIFT_REGISTER_LATCH = 2
  
CON                     
                     
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MILLISECOND = CLK_FREQ / 1_000

  DEFAULT_INTERVAL = MILLISECOND * 10
  
  MAX_DISPLAYABLE = 99_999_999

OBJ

  Led : "Eight7Segments140905e"
    
PUB Setup 

  Led.Start(SHIFT_REGISTER_DATA, SHIFT_REGISTER_CLOCK, SHIFT_REGISTER_LATCH, "0")
  
  MainLoop
  
PUB MainLoop | numberToDisplay, timer

  timer := cnt + DEFAULT_INTERVAL

  repeat
    repeat numberToDisplay from 0 to MAX_DISPLAYABLE
      if numberToDisplay // 2000 == 0
        Led.SetPadBits(Led#PAD_BITS_ZERO)
      elseif numberToDisplay // 1000 == 0
        Led.SetPadBits(Led#PAD_BITS_SPACE)
        
      Led.Set(numberToDisplay)  
      waitcnt(timer)
      timer += DEFAULT_INTERVAL
